﻿using DapperORM.Common.Models;
using PushInfo.Core.Models.Tables;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace PushInfo.Core.IDAL
{
    /// <summary>
    /// 项目表访问层接口
    /// </summary>
    internal interface IProjectInfo
    {
        /// <summary>
        /// 查询单条记录
        /// </summary>
        /// <param name="where"></param>
        /// <param name="select"></param>
        /// <param name="sort"></param>
        /// <returns></returns>
        ResultModel<Project_Info> GetModel(Expression<Func<Project_Info, bool>> where = null, Expression<Func<Project_Info, object>> select = null, IDictionary<string, bool> sort = null);

        /// <summary>
        /// 查询集合
        /// </summary>
        /// <param name="where">查询条件</param>
        /// <param name="select">查询字段</param>
        /// <param name="sort">排序</param>
        /// <returns></returns>
        ResultModel<IEnumerable<Project_Info>> GetList(Expression<Func<Project_Info, bool>> where = null, Expression<Func<Project_Info, object>> select = null, IDictionary<string, bool> sort = null);

    }
}
